/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.xtext.example.methodname.methodName.Case;
import org.xtext.example.methodname.methodName.Declaration;
import org.xtext.example.methodname.methodName.FixedDeclaration;
import org.xtext.example.methodname.methodName.MethodNamePackage;
import org.xtext.example.methodname.methodName.Model;
import org.xtext.example.methodname.methodName.Rule;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.ModelImpl#getDeclarations <em>Declarations</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.ModelImpl#getFixedDeclarations <em>Fixed Declarations</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.ModelImpl#getRules <em>Rules</em>}</li>
 *   <li>{@link org.xtext.example.methodname.methodName.impl.ModelImpl#getElements <em>Elements</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ModelImpl extends MinimalEObjectImpl.Container implements Model
{
  /**
   * The cached value of the '{@link #getDeclarations() <em>Declarations</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDeclarations()
   * @generated
   * @ordered
   */
  protected EList<Declaration> declarations;

  /**
   * The cached value of the '{@link #getFixedDeclarations() <em>Fixed Declarations</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFixedDeclarations()
   * @generated
   * @ordered
   */
  protected EList<FixedDeclaration> fixedDeclarations;

  /**
   * The cached value of the '{@link #getRules() <em>Rules</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRules()
   * @generated
   * @ordered
   */
  protected EList<Rule> rules;

  /**
   * The cached value of the '{@link #getElements() <em>Elements</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getElements()
   * @generated
   * @ordered
   */
  protected EList<Case> elements;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ModelImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MethodNamePackage.Literals.MODEL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<Declaration> getDeclarations()
  {
    if (declarations == null)
    {
      declarations = new EObjectContainmentEList<Declaration>(Declaration.class, this, MethodNamePackage.MODEL__DECLARATIONS);
    }
    return declarations;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<FixedDeclaration> getFixedDeclarations()
  {
    if (fixedDeclarations == null)
    {
      fixedDeclarations = new EObjectContainmentEList<FixedDeclaration>(FixedDeclaration.class, this, MethodNamePackage.MODEL__FIXED_DECLARATIONS);
    }
    return fixedDeclarations;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<Rule> getRules()
  {
    if (rules == null)
    {
      rules = new EObjectContainmentEList<Rule>(Rule.class, this, MethodNamePackage.MODEL__RULES);
    }
    return rules;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EList<Case> getElements()
  {
    if (elements == null)
    {
      elements = new EObjectContainmentEList<Case>(Case.class, this, MethodNamePackage.MODEL__ELEMENTS);
    }
    return elements;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case MethodNamePackage.MODEL__DECLARATIONS:
        return ((InternalEList<?>)getDeclarations()).basicRemove(otherEnd, msgs);
      case MethodNamePackage.MODEL__FIXED_DECLARATIONS:
        return ((InternalEList<?>)getFixedDeclarations()).basicRemove(otherEnd, msgs);
      case MethodNamePackage.MODEL__RULES:
        return ((InternalEList<?>)getRules()).basicRemove(otherEnd, msgs);
      case MethodNamePackage.MODEL__ELEMENTS:
        return ((InternalEList<?>)getElements()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MethodNamePackage.MODEL__DECLARATIONS:
        return getDeclarations();
      case MethodNamePackage.MODEL__FIXED_DECLARATIONS:
        return getFixedDeclarations();
      case MethodNamePackage.MODEL__RULES:
        return getRules();
      case MethodNamePackage.MODEL__ELEMENTS:
        return getElements();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MethodNamePackage.MODEL__DECLARATIONS:
        getDeclarations().clear();
        getDeclarations().addAll((Collection<? extends Declaration>)newValue);
        return;
      case MethodNamePackage.MODEL__FIXED_DECLARATIONS:
        getFixedDeclarations().clear();
        getFixedDeclarations().addAll((Collection<? extends FixedDeclaration>)newValue);
        return;
      case MethodNamePackage.MODEL__RULES:
        getRules().clear();
        getRules().addAll((Collection<? extends Rule>)newValue);
        return;
      case MethodNamePackage.MODEL__ELEMENTS:
        getElements().clear();
        getElements().addAll((Collection<? extends Case>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.MODEL__DECLARATIONS:
        getDeclarations().clear();
        return;
      case MethodNamePackage.MODEL__FIXED_DECLARATIONS:
        getFixedDeclarations().clear();
        return;
      case MethodNamePackage.MODEL__RULES:
        getRules().clear();
        return;
      case MethodNamePackage.MODEL__ELEMENTS:
        getElements().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MethodNamePackage.MODEL__DECLARATIONS:
        return declarations != null && !declarations.isEmpty();
      case MethodNamePackage.MODEL__FIXED_DECLARATIONS:
        return fixedDeclarations != null && !fixedDeclarations.isEmpty();
      case MethodNamePackage.MODEL__RULES:
        return rules != null && !rules.isEmpty();
      case MethodNamePackage.MODEL__ELEMENTS:
        return elements != null && !elements.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //ModelImpl
